/***************************************************************************
 *            socket.h
 *
 *  Thu Jul  1 00:36:23 2004
 *  Copyright  2004  Michael Rasmussen
 *  mir@miras.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _SOCKET_H
#define _SOCKET_H

#ifdef __cplusplus
extern "C"
{
#endif
	
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/utsname.h>
#include <netinet/in.h>
#include <signal.h>
#include <netdb.h>
#include <errno.h>
#include <time.h>
	
#define SOCKETSIZE sizeof(Tcpsocket)
#define S_PORT_ERR	-100
#define S_SOCK_ERR	-101
#define S_WAIT_ERR	-102
#define S_TIME_ERR	-103
#define S_RECV_ERR	-104
#define S_SEND_ERR	-105
#define S_HOST_ERR	-106
#define S_INET_ERR	-107
	
typedef struct Tcpsocket {
	int	fd;
	struct sockaddr_in addr;
} Tcpsocket;

// Prototypes

// TCP functions
Tcpsocket	initTcpServer(int port, int max);
int			listenServer(Tcpsocket server);
void		closeServer(Tcpsocket server);
int			initTcpClient(char *host, int port);
int			readSocket(int sock, char *buf, int max);
int			readLSocket(int sock, char *buff, int maxsize);
int			writeSocket(int sock, char *buff, int size);

// Utilities
void		noZombie(int sig);
int			getIP(char *host, char *ip);
int			hostName(char *host, char *fqdn);
int			domainName(char *ip, char *fqdn);
void		getPeerIp(int sock, char *ipfrom, char *hostfrom);

#ifdef __cplusplus
}
#endif

#endif /* _SOCKET_H */
