/***************************************************************************
 *            socketClass.cc
 *
 *  Thu Jul  1 20:35:29 2004
 *  Copyright  2004  Michael Rasmussen
 *  mir@miras.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <unistd.h>
#include "socketClass.h"

SocketServer::SocketServer(int port, int maxcon) {
	server = initTcpServer(port, maxcon);
	if (server.fd == -1)
		throw SocketException();
}

void SocketServer::Init(int port, int maxcon) {
	this->server = initTcpServer(port, maxcon);
	if (this->server.fd == -1)
		throw SocketException();
}

bool SocketServer::Start() {
char from[100], ip[15];
	
	if ((this->fd = listenServer(this->server)) < 0)
		return false;
	else {
		getPeerIp(this->fd, ip, from);
		setClientData(from, ip);
		return true;
	}
}

int SocketServer::Read(string &buffer, int size) {
	char *s = (char *) malloc(MAXBUFSIZE + 1);
	int i;
	
	if ((i = readLSocket(this->fd, s, strlen(s))) == 0)
		buffer = s;
	return i;
}

int	SocketServer::Readln(string &buffer) {
	char *s = (char *) malloc(MAXBUFSIZE + 1);
	int i;
	
	if ((i = readLSocket(this->fd, s, strlen(s))) == 0)
		buffer = s;
	return i;
}

int	SocketServer::Write(string &buffer) {
	char *s = (char *) buffer.c_str();
	
	return writeSocket(this->fd, s, strlen(s));
}

int	SocketServer::Write(const char *s) {
	return writeSocket(this->fd, (char *) s, strlen(s));
}

void SocketServer::Close() {
	close(this->fd);
}

void SocketServer::Stop() {
	closeServer(this->server);
}

string SocketServer::getClientIp() {
	return getIp();
}

string SocketServer::getClientHost() {
	return getHostname();
}

void SocketServer::setFd(int fd) {
char from[100], ip[15];

	this->fd = fd;
	getPeerIp(this->fd, ip, from);
	setClientData(from, ip);
}

int SocketServer::getFd() {
	return this->fd;
}
